import Project, { ClassDeclaration, EnumDeclaration, FunctionDeclaration, InterfaceDeclaration, SourceFile, VariableDeclaration } from "ts-simple-ast";
/** meaning that it moved by this refactor */
export declare type MovableDeclaration = ClassDeclaration | FunctionDeclaration | InterfaceDeclaration | VariableDeclaration | EnumDeclaration;
export declare function moveDeclarationNamed(declarationName: string, file: SourceFile, project: Project, targetFile: SourceFile): void;
/**
 * Moves a top level declaration to another file. See all todo comments along the code to  get idea of current
 * state / issue. The resulting project state should not have errors. We do two important things:
 *
 * 1) fix all imports pointing to target declaration in all files of the project so they point now to the new
 *    location (target file)
 * 2) all nodes referenced inside the target declaration must be now imported in the target file (so the
 *    declaration can still see them)
 *
 * **Very WIP dont use it in production yet!**
 *
 * @param c the declaration node to move
 * @param project project in which to do the refactor
 * @param targetFile the target file, inside the project where to move the class
 */
export declare function moveDeclaration(c: MovableDeclaration, project: Project, targetFile: SourceFile): void;
